unit Core;
interface
uses SysUtils,Classes,fparse;

const CMD_NOP     = 0;
      CMD_LET     = 1;
      CMD_WRITE   = 2;
      CMD_WRITELN = 3;
      CMD_INPUT   = 4;
      CMD_GOTO    = 5;
      CMD_IF      = 6;
      CMD_IF_GOTO = 7;
      CMD_SKIP    = 8;
      CMD_EXIT    =99;

type TCommand=record
                Cmd:integer;       // command type (see above)
                Op:char;           // variable / label operand
                Expr:PExpTreeNode; // expression tree
                Ref1,Ref2:integer; // pointers to instructions / length/decimals
                Str:string;        // string constant
              end;
const NewCommand:TCommand=(Cmd:CMD_NOP;Op:#0;Expr:nil;Ref1:-1;Ref2:-1;Str:'');

type TProgram=record
                Code:array of TCommand;
              end;

const CINPUT=$800000;
      COUTPUT=$008000;
      CERROR=$000080;

procedure ExecImmediate(const Statement:string);

var CompileError:boolean;
function Compile(Source:TStrings):TProgram;

procedure DestroyProgram(var Prog:TProgram);

implementation
uses Main;

{$I Compile.inc}

procedure ExecImmediate(const Statement:string);
var Code:TStringList;
begin
  Code:=TStringList.Create;
  Code.Add(Statement);
  MainForm.Prog:=Compile(Code);
  Code.Free;
  MainForm.ExecProg;
end;

procedure DestroyProgram(var Prog:TProgram);
var i:integer;
begin
  for i:=Low(Prog.Code) to High(Prog.Code) do
    with Prog.Code[i] do begin
      DestroyExpressionTree(Expr);
      Finalize(Str);
    end;
  Finalize(Prog.Code);
end;

end.
