const FID_BINARY       = $9000;
      FID_LOG          = FID_BINARY OR $001;
      FID_ROOT         = FID_BINARY OR $002;
      FID_MOD          = FID_BINARY OR $003;
      FID_FMOD         = FID_BINARY OR $004;
      FID_AND          = FID_BINARY OR $F01;
      FID_OR           = FID_BINARY OR $F02;
//      FID_ = FID_BINARY OR $000;

function CalcBasicBinaryFunctions(ID:integer;const a,b:double):double;
begin case ID of
  FID_LOG     :Result:=LogN(a,b);
  FID_ROOT    :Result:=Power(a,1.0/b);
  FID_MOD     :Result:=round(a) MOD round(b);
  FID_FMOD    :Result:=a-trunc(a/b)*b;
  FID_AND     :Result:=integer((a<>0.0) AND (b<>0.0));
  FID_OR      :Result:=integer((a<>0.0) OR (b<>0.0));
//  FID_ :Result:=XXXXXXXX(a);
else Result:=0.0; MathError:=true; end; end;

const NumberOfBasicBinaryFunctions=7;
const BasicBinaryFunctions:array[0..NumberOfBasicBinaryFunctions-1]of TBinaryFunction=(
  (Name: 'log';     ID:FID_LOG;     Proc:CalcBasicBinaryFunctions),
  (Name: 'root';    ID:FID_ROOT;    Proc:CalcBasicBinaryFunctions),
  (Name: 'mod';     ID:FID_MOD;     Proc:CalcBasicBinaryFunctions),
  (Name: 'fmod';    ID:FID_FMOD;    Proc:CalcBasicBinaryFunctions),
  (Name: 'and';     ID:FID_AND;     Proc:CalcBasicBinaryFunctions),
  (Name: 'or';      ID:FID_OR;      Proc:CalcBasicBinaryFunctions),
//  (Name: ''; ID:FID_; Proc:CalcBasicBinaryFunctions),
  (Name: 'NULL';    ID:0;           Proc:CalcBasicBinaryFunctions)
);
